from sympy import *

p = Symbol("p", integer=True, positive=True)

#notation
#----------------------------------------------------------------------#
btt = Symbol("btbt", real=True, nonnegative=True)
bcc = Symbol("bcbc", real=True, nonnegative=True)
btc = Symbol("btbc", real=True, nonnegative=False)
bt_p_bc_2 = btt + bcc + 2*btc
bt_m_bc_2 = btt + bcc - 2*btc
B = Matrix([[btt-btc],
            [-btc+bcc]])
A = Matrix([[btt + p, -btc],
            [-btc   , bcc + p]])
AiB = simplify(A.inv()*B)
AiBm1 = AiB-Matrix([[1],[1]])
K = 1/((btt+p)*(bcc+p)-(btc)**2)
#----------------------------------------------------------------------#

    

print('simplifying (16)-(17)')



alphas16 = simplify(AiB)
alphas17 = Matrix([[1],[1]]) - K*p*Matrix([bcc+btc+p,btt+btc+p])

if simplify(alphas17 - alphas16)==Matrix([[0],[0]]):
    pprint('OK')



print('proving equation (20)')

alphasm1 = alphas17-Matrix([[1],[1]])

bTmbCt_mul_bTmbC = Matrix([[btt, -btc],
                           [-btc, bcc]])
left20 = simplify(alphasm1.T*bTmbCt_mul_bTmbC*alphasm1)[0,0]

qt = p*(bcc+btc+p)
qc = p*(btt+btc+p)
right20 = (qt*qt*btt-2*qt*qc*btc+qc*qc*bcc)*K**2

if simplify(left20-right20)==0:
    pprint('OK')

print('simplifying (20)-(21)')

final_part_of_mse21= (p**4*bt_m_bc_2
                  + p**2*(btt*bcc - btc**2)
                  *(bt_p_bc_2 + 4*p)) * K**2

if simplify(left20-final_part_of_mse21)==0:
    pprint('OK')

print('simplifying (25)+(26)-(27)')
dAiB_dbt = Matrix([[p,0]])*AiB\
           + 2*Matrix([[btt,-btc]])*AiB.diff(btt)\
           + Matrix([[btc,-bcc]])*AiB.diff(btc)
dAiB_dbc = Matrix([[0,p]])*AiB\
           - 2*Matrix([[btc,-bcc]])*AiB.diff(bcc)\
           - Matrix([[btt,-btc]])*AiB.diff(btc)
deriv2526 = 2*(dAiB_dbt + dAiB_dbc)

deriv27 =  2*(Matrix([[p,p]])*AiB -\
                Matrix([[3*btt*bcc-3*btc**2+2*btt*p+bcc*p-btc*p,
                         3*btt*bcc-3*btc**2+2*bcc*p+btt*p-btc*p]])*K * AiBm1)
if simplify(deriv2526-deriv27)==Matrix([[0]]):
    pprint('OK')



print('simplifying (27)-(28)')
alpha_t_m1 = AiBm1[0,0]
alpha_c_m1 = AiBm1[1,0]
final_part_of_mse28= 4*p + 2*(p-3)*(alpha_t_m1+alpha_c_m1) - 4*p*p*K - 4*(alpha_t_m1)**2 - 4*(alpha_c_m1)**2
if simplify(final_part_of_mse28- deriv27[0,0])==0:
   pprint('OK') 


print('proving that (28)+(21)-(18)=(expression from 30 to 37)')

final_part_of_mse18=2*p
final_mse282518 = final_part_of_mse28 + final_part_of_mse21 - final_part_of_mse18
final_mse_from_30_to_37 = 2*p-(p*(p-6)*bt_p_bc_2*(btt*bcc-btc**2) # <= 0
                       +2*p*p*(p-3)*bt_p_bc_2*(btt+bcc) 
                       +2*p*p*p*(p-3)*bt_p_bc_2       #  <= 0
                       -8*p*p*(btt*bcc-btc**2)    
                       +4*p**3*(p-2)*(btt+bcc+p)  
                       +4*p*p*(btt+btc+p)**2      
                       +4*p*p*(bcc+btc+p)**2      
                       -p**4*bt_m_bc_2) * K**2    
if simplify(final_mse282518 -final_mse_from_30_to_37)==0:
   pprint('OK')  


print('proving that (32)+(34)+(36)=(38)+(39)+(40)')


final_mse323436= -2*p*p*(p-3)*bt_p_bc_2*(btt+bcc) \
             +8*p*p*(btt*bcc-btc**2) \
             -4*p*p*(btt+btc+p)**2 \
             -4*p*p*(bcc+btc+p)**2
final_mse383940 = -2*p*p*(p-5)*bt_p_bc_2*(btt + bcc) \
                -8*p*p*(btt+btc)**2 \
                -8*p*p*(bcc+btc)**2 \
                -8*p**3*(bt_p_bc_2 + p)
if simplify(final_mse323436 - final_mse383940)==0:
   pprint('OK')
